diff --git a/src/Fl_Text_Display.cxx b/src/Fl_Text_Display.cxx
index d747b1c..3ddbc71 100644
--- a/src/Fl_Text_Display.cxx
+++ b/src/Fl_Text_Display.cxx
@@ -2126,6 +2126,7 @@ void Fl_Text_Display::draw_string(int style,
   int fsize = textsize();
   Fl_Color foreground;
   Fl_Color background;
+  Fl_Color bgcolor = color(); // default background color
 
   if ( style & STYLE_LOOKUP_MASK ) {
     int si = (style & STYLE_LOOKUP_MASK) - 'A';
@@ -2135,6 +2136,7 @@ void Fl_Text_Display::draw_string(int style,
     styleRec = mStyleTable + si;
     font  = styleRec->font;
     fsize = styleRec->size;
+    bgcolor = styleRec->attr ? styleRec->attr : color(); // background color from Style_Table_Entry
 
     if (style & PRIMARY_MASK) {
       if (Fl::focus() == (Fl_Widget*)this) {
@@ -2144,23 +2146,23 @@ void Fl_Text_Display::draw_string(int style,
 #endif
 	background = selection_color();
 	}
-      else background = fl_color_average(color(), selection_color(), 0.4f);
+      else background = fl_color_average(bgcolor, selection_color(), 0.4f);
     } else if (style & HIGHLIGHT_MASK) {
-      if (Fl::focus() == (Fl_Widget*)this) background = fl_color_average(color(), selection_color(), 0.5f);
-      else background = fl_color_average(color(), selection_color(), 0.6f);
-    } else background = color();
-    foreground = (style & PRIMARY_MASK) ? fl_contrast(styleRec->color, background) : styleRec->color;
+      if (Fl::focus() == (Fl_Widget*)this) background = fl_color_average(bgcolor, selection_color(), 0.5f);
+      else background = fl_color_average(bgcolor, selection_color(), 0.6f);
+    } else background = bgcolor;
+    foreground = (style & PRIMARY_MASK) ? fl_contrast(bgcolor, background) : styleRec->color;
   } else if (style & PRIMARY_MASK) {
     if (Fl::focus() == (Fl_Widget*)this) background = selection_color();
-    else background = fl_color_average(color(), selection_color(), 0.4f);
+    else background = fl_color_average(bgcolor, selection_color(), 0.4f);
     foreground = fl_contrast(textcolor(), background);
   } else if (style & HIGHLIGHT_MASK) {
-    if (Fl::focus() == (Fl_Widget*)this) background = fl_color_average(color(), selection_color(), 0.5f);
-    else background = fl_color_average(color(), selection_color(), 0.6f);
+    if (Fl::focus() == (Fl_Widget*)this) background = fl_color_average(bgcolor, selection_color(), 0.5f);
+    else background = fl_color_average(bgcolor, selection_color(), 0.6f);
     foreground = fl_contrast(textcolor(), background);
   } else {
     foreground = textcolor();
-    background = color();
+    background = bgcolor;
   }
 
   if ( !active_r() ) {
